160 相交链表

本文探讨了如何在O(n)时间和O(1)空间复杂度下找到两个单链表的相交起始节点。通过比较链表长度并同步移动长链表的节点,或者使用双指针同步遍历消除长度差,可以实现这一目标。此外,还提到了使用哈希表作为备选解决方案。这些方法对于处理链表相交问题非常有效。
摘要由CSDN通过智能技术生成
//编写一个程序,找到两个单链表相交的起始节点。 
//
// 如下面的两个链表: 
//
// 
//
// 在节点 c1 开始相交。 
//
// 
//
// 示例 1: 
//
// 
//
// 输入:intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, s
//kipB = 3
//输出:Reference of the node with value = 8
//输入解释:相交节点的值为 8 (注意,如果两个链表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为 [5,0,1
//,8,4,5]。在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。
// 
//
// 
//
// 示例 2: 
//
// 
//
// 输入:intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB =
// 1
//输出:Reference of the node with value = 2
//输入解释:相交节点的值为 2 (注意,如果两个链表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [0,9,1,2,4],链表 B 为 [3,2,4
//]。在 A 中,相交节点前有 3 个节点;在 B 中,相交节点前有 1 个节点。
// 
//
// 
//
// 示例 3: 
//
// 
//
// 输入:intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
//输出:null
//输入解释:从各自的表头开始算起,链表 A 为 [2,6,4],链表 B 为 [1,5]。由于这两个链表不相交,所以 intersectVal 必须为 0,而
// skipA 和 skipB 可以是任意值。
//解释:这两个链表不相交,因此返回 null。
// 
//
// 
//
// 注意: 
//
// 
// 如果两个链表没有交点,返回 null. 
// 在返回结果后,两个链表仍须保持原有的结构。 
// 可假定整个链表结构中没有循环。 
// 程序尽量满足 O(n) 时间复杂度,且仅用 O(1) 内存。 
// 
// Related Topics 链表 
// 👍 935 👎 0
PS,1方法要比使用hash表还快。

1.思路:为了找到公共节点,必须保持两个表长度一致同步,才能匹配。

 

所以先获取链表长度,长表先移动相差的步数,最后再同步移动,直到两者地址相同,或者移动到最后。
通过1 ms41.1 MBJava

//leetcode submit region begin(Prohibit modification and deletion)

import javax.swing.*;
import java.util.List;

/**
 * Definition for singly-linked list.
 * public class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) {
 *         val = x;
 *         next = null;
 *     }
 * }
 */
public class Solution {
    public int getLen(ListNode head){
        int count=1;
        ListNode p = head;
        while(p!=null){
            p=p.next;
            count++;
        }
        return count;
    }
    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        int lena=getLen(headA);
        int lenb=getLen(headB);

        if(lena>lenb){
            for(int i=0;i<lena-lenb;i++){
                headA=headA.next;
            }
        }else if(lena<lenb){
            for(int i=0;i<lenb-lena;i++){
                headB=headB.next;
            }
        }

        while(headA!=headB&&headA!=null&&headB!=null){
            headA=headA.next;
            headB=headB.next;
        }
        return headA;
    }
}
//leetcode submit region end(Prohibit modification and deletion)

2.消除长度差

            执行耗时:1 ms,击败了99.99% 的Java用户
            内存消耗:41.2 MB,击败了60.50% 的Java用户

public class Solution {

    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        //关键,同步指针,如何处理长度差呢?按照 A-B  和  B-A  连接,很明显长度差就消除了。
        //两者的和是相等的,那么将两个表拼接,长度就一致了,
        // 最终退出条件是要么走到相同位置,要么走到最后一个null指针相同,退出
        ListNode pa=headA,pb=headB;
        while(pa!=pb){
            pa = pa!=null?pa.next:headB;
            pb = pb!=null?pb.next:headA;
        }
        return pa;
    }
}

 

 3.使用hash表,先将a表存到hash表中,再遍历表检查是否相同

通过8 ms42.4 MBJava

public class Solution {

    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        HashSet <ListNode> set= new HashSet<>();
        while(headA!=null){
            set.add(headA);
            headA=headA.next;
        }
        while(headB!=null){
            if(set.contains(headB)){
                break;
            }
            headB=headB.next;
        }
        return headB;
    }
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值